function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, useEffect, useContext } from 'react';
import { Button, Input } from 'antd';
import { ConfigHoc, ConfigContext } from "../../../config-provider/context";
import EmojiPanel from "../emoji-panel";
import "./index.less";
var TextArea = Input.TextArea;
var Comment = function Comment(props) {
  var componentContext = useContext(ConfigContext);
  var uiLocale = componentContext.uiLocale;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    inputValue = _useState2[0],
    setInputValue = _useState2[1];
  var _useState3 = useState(0),
    _useState4 = _slicedToArray(_useState3, 2),
    insertIndex = _useState4[0],
    setInsertIndex = _useState4[1];
  var onChangeInput = function onChangeInput(value) {
    setInputValue(value);
    props.onChange && props.onChange(value);
  };
  var getCursorIndex = function getCursorIndex(ev) {
    return setInsertIndex(ev.target.selectionStart);
  };
  var onSubmit = function onSubmit() {
    props.onSubmit && props.onSubmit(inputValue);
  };

  // 父级value发生变化，同步内
  useEffect(function () {
    props.value && setInputValue(props.value);
  }, [props.value]);
  return /*#__PURE__*/React.createElement("div", {
    className: "u-comment-input"
  }, /*#__PURE__*/React.createElement(TextArea, {
    onBlur: getCursorIndex,
    value: inputValue,
    onChange: function onChange(ev) {
      return onChangeInput(ev.target.value);
    },
    rows: 4
  }), /*#__PURE__*/React.createElement("div", {
    className: "btn-wrapper"
  }, props.emojiType && /*#__PURE__*/React.createElement(EmojiPanel, {
    type: props.emojiType,
    value: inputValue,
    insertIndex: insertIndex,
    onChangeInput: onChangeInput
  }), props.extra && /*#__PURE__*/React.createElement("div", {
    className: "btn-extra"
  }, props.extra), /*#__PURE__*/React.createElement(Button, {
    className: "submit",
    type: "primary",
    onClick: onSubmit
  }, uiLocale.global.submitText)));
};
export default ConfigHoc(Comment);